-- 获得新宠物
Lua_NewFeatureDisplayWindow = class("Lua_NewFeatureDisplayWindow", Lua_Window);
function Lua_NewFeatureDisplayWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_NewFeatureDisplayWindow";
	self.skinName = "FeatureModelPanel_skin";
	self.showClose = false;
end

function Lua_NewFeatureDisplayWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_newfunction_1", "gui_newfunction_1", 6, 95);
	self.effect:SetRenderQueue(self.bg, 2, 2, false);
	
	self.okBtn:addClickFuntion(self, self.onOkClick);
	-- self:addLuaEvent("CLOSE_FUNC_OPEN_MODEL", self, self.hide);
end

function Lua_NewFeatureDisplayWindow:showWin(param)
	self:superCall("showWin", param);

	self.curFeatureInfo = param.featureData:getServantShapeList()[param.featureData.stage];
	self.tipsLab.text = param.featureData:getShapConfig()[param.featureData.stage][3];

	self:showModel();
end

function Lua_NewFeatureDisplayWindow:showModel()
	-- self.curFeatureInfo.id = 702010001;
	-- --self.showData.animType = 1;
	-- --self.showData.modelType = 2;

	local featureData = self.showData.featureData;
	local modelInfo;
	if self.showData.panelName == "Lua_FootprintPanel" then
		modelInfo = featureData:getEffectInfo(self.curFeatureInfo.id);
	else
		modelInfo = featureData:getModelInfo(self.curFeatureInfo.id);
	end

	local displayModelInfo = featureData:getDisplayModelInfo(self.curFeatureInfo.id);
	local root = displayModelInfo.root;
	local uieffect = displayModelInfo.uieffect;

	if self.showData.modelType == nil then
		return;
	elseif self.showData.modelType == 1 then
		self.model = UIModelTexture();
		local imgPos = Vector2(0, 110);
		local imgSize = Vector2(1280, 503);
    	local modelRot = Vector3(0, 0, 0);
    	local modelOffset = Vector2(0, 0);
		self.model:init(self.content,imgPos,imgSize, 5, modelRot,modelOffset, 360);
		-- self.model:setRotEnable(true, -228, 71, 665, 400, 2);
		self.model:setCamView(displayModelInfo.camView);
		self.model:setCamPos(5000, 0, 0);

		if root ~= nil then
			self.model:setModelOffset(root.pos[1],root.pos[2]);
			-- self.model.root.transform.localEulerAngles = Vector3(root.rot[1], root.rot[2], root.rot[3]);
			-- self.model.root.transform.localScale = Vector3(root.sca[1], root.sca[2], root.sca[3]);
		    LuaUtil.setObjRot(self.model.root, root.rot[1], root.rot[2], root.rot[3]);
			LuaUtil.setObjScale(self.model.root, root.sca[1], root.sca[2], root.sca[3]);
		end

		if uieffect ~= nil then
			self.model:setEffectPos(uieffect.pos[1], uieffect.pos[2], uieffect.pos[3]);
			self.model:setModelAngle(uieffect.rot[1], uieffect.rot[2], uieffect.rot[3]);
			self.model.uiEffect:setSacle(uieffect.sca[1], uieffect.sca[2], uieffect.sca[3]);
		end
		self.rootGo = self.model.root;
	elseif self.showData.modelType == 2 then
		local rootGo = UICreate.createGameObject(self.content, 0, 0);
		rootGo.name = "uiEffectRoot";
		
		self.model = UICreate.createUIEffect(rootGo, nil, nil, 0, 0);
		self.model:SetRenderQueue(self.bg, 2, 2, false);
		if root ~= nil then
			-- rootGo.transform.localEulerAngles = Vector3(root.rot[1], root.rot[2], root.rot[3]);
			-- rootGo.transform.localScale = Vector3(root.sca[1], root.sca[2], root.sca[3]);
			-- rootGo.transform.localPosition = Vector3(root.pos[1], root.pos[2], root.pos[3]);
		    LuaUtil.setObjRot(rootGo, root.rot[1], root.rot[2], root.rot[3]);
			LuaUtil.setObjScale(rootGo, root.sca[1], root.sca[2], root.sca[3]);
			LuaUtil.setObjPos(rootGo, root.pos[1], root.pos[2], root.pos[3]);
		end

		if uieffect ~= nil then
			-- self.model.mainContent.transform.localEulerAngles = Vector3(uieffect.rot[1], uieffect.rot[2], uieffect.rot[3]);
			-- self.model.mainContent.transform.localScale = Vector3(uieffect.sca[1], uieffect.sca[2], uieffect.sca[3]);
			-- self.model.mainContent.transform.localPosition = Vector3(uieffect.pos[1], uieffect.pos[2], uieffect.pos[3]);
		    LuaUtil.setObjRot(self.model.mainContent, uieffect.rot[1], uieffect.rot[2], uieffect.rot[3]);
			LuaUtil.setObjScale(self.model.mainContent, uieffect.sca[1], uieffect.sca[2], uieffect.sca[3]);
			LuaUtil.setObjPos(self.model.mainContent, uieffect.pos[1], uieffect.pos[2], uieffect.pos[3]);
		end
		self.rootGo = rootGo;
	end

	if modelInfo == nil then
		self.model:setUrl("/mounts/"..self.curFeatureInfo.id,tostring(self.curFeatureInfo.id));
	else
		if self.showData.panelName == "Lua_FootprintPanel" then
			self.model:setUrl(modelInfo.floder.."/"..modelInfo.path,tostring(modelInfo.path));
		else
			self.model:setUrl(modelInfo.floder.."/"..modelInfo.fileName,tostring(modelInfo.modelName));
		end
	end

	if self.showData.animType == 1 and self.showData.modelType == 1  then
		self.model:setAction(1);
	end

	if self.showData.panelName == "Lua_FootprintPanel" then
		Lua_CommonUtil.addTimer("FootPrintEffect", 2, self, self.effectLoop);
	end
end

function Lua_NewFeatureDisplayWindow:onOkClick(go)
	self:hide();

	if self.showData.winType == 1 then
		Lua_WindowUtil.openWin("Lua_PetWindow", WinParam.ACTION_OPEN, {openIdx = self.showData.panelIndex});
	elseif self.showData.winType == 2 then
		Lua_WindowUtil.openWin("Lua_FeatureMainWindow", WinParam.ACTION_OPEN, {openIdx = self.showData.panelIndex});
	end
end

function Lua_NewFeatureDisplayWindow:effectLoop()
	if self.model == nil then
		return;
	end

	if self.rootGo ~= nil then
		self.rootGo:SetActive(false);
		self.rootGo:SetActive(true);
	end
end

function Lua_NewFeatureDisplayWindow:dispose()
	if self.model ~= nil then
		self.model:dispose();
		self.model = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.effectLoop);

	self:superCall("dispose");
end