-- 侍宠-灵丹
Lua_PetPanaceaDetailWindow = class("Lua_PetPanaceaDetailWindow", Lua_Window);
function Lua_PetPanaceaDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_PetPanaceaDetailWindow";
	self.skinName = "PetPanaceaDetailWindow_skin";
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_PetPanaceaDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.toolImagePosObj.gameObject);
	self.itemImg:setDepth(3);

	self.outPutTxt.clickScale = false;
	self.outPutTxt:addUrlClickFuntion(self, self.onDescTxtUrlClick);
end

function Lua_PetPanaceaDetailWindow:showWin(param)
	self.data = param;
	self.itemImg.data = param;
	self.itemImg:setCanClick(false);

	self.nameTxt.uiwidget.text = param.name;
	self.usedNumTxt.uiwidget.text = param.count .. "/" .. param.cond.limit;
	self.outPutTxt.text = param.outputDes;

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, -16, 335, 250));
	self.dragContainer:setLocation(-5, -11, 0);
	self.curEffect = Lua_PetPanaceaDetailPanel.new(self.dragContainer, param);
	self.curEffect:setLocation(17, 0, 0);
	self:setTopColor(param);
end

function Lua_PetPanaceaDetailWindow:setTopColor(data)
	if data.color == 1 then
		self.topColorSp:setAltas("common_atlas_1", "ui_common_tips_02_lv");
		self.nameTxt.color = Color.New(0/255, 225/255, 37/255, 1);
	elseif data.color == 2 then
		self.topColorSp:setAltas("common_atlas_1", "ui_common_tips_02_lan");
		self.nameTxt.color = Color.New(0/255, 192/255, 1, 1);
	elseif data.color == 3 then
		self.topColorSp:setAltas("common_atlas_1", "ui_common_tips_02_zi");
		self.nameTxt.color = Color.New(188/255, 59/255, 1, 1);
	elseif data.color == 4 then
		self.topColorSp:setAltas("common_atlas_1", "ui_common_tips_02_huang");
		self.nameTxt.color = Color.New(1, 179/255, 25/255, 1);
	elseif data.color == 5 then
		self.topColorSp:setAltas("common_atlas_1", "ui_common_tips_02_hong");
		self.nameTxt.color = Color.New(1, 22/255, 22/255, 1);
	else
		return;
	end
end

function Lua_PetPanaceaDetailWindow:onDescTxtUrlClick(url)
	local list = self.data:getOutputDesInfo(url);
	if list ~= nil and Lua_PackUtil.checkOpenWinFunOpen(list) == true then
		Lua_WindowUtil.openWin("Lua_PetPanaceaDetailWindow", WinParam.ACTION_CLOSE);
		
		local itemID;
		if list[1].winName == "Lua_ShopWindow" and list[1].itemID ~= nil then
			if type(list[1].itemID) == "table" then
				itemID = list[1].itemID[DataCenter.roleData.career];
			elseif type(list[1].itemID) == "number" then
				itemID = list[1].itemID;
			end
		end
		Lua_PackUtil.openWinByList(list, nil, nil, false, itemID);
	end
end





--------------------------------------------------





Lua_PetPanaceaDetailPanel = class("Lua_PetPanaceaDetailPanel", Lua_DragContainerItem);
function Lua_PetPanaceaDetailPanel:ctor(dragContainer, data, height)
	self.data = data;
	self.height =(height == nil) and 54.8 or height;
	self.dragContainer = dragContainer;
	self:superCall("ctor", dragContainer.sub, "PetPanaceaDetailPanel_skin");
	dragContainer:addSubContainer(self, true);
end

function Lua_PetPanaceaDetailPanel:buildShowItem()
	self:superCall("buildShowItem");
	
	self:updataDesText(self.data);
end

function Lua_PetPanaceaDetailPanel:updataDesText(data)
	self.data = data;
	local attrTxtArr = Array();
	local force = self.data.danyao_zhanli;
	local forceTxt;
	if force ~= 0 then
		forceTxt = UICreate.createLabel(self.content, "", -172, 65, 235, 22, 22);
		forceTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
		forceTxt.pivot = UIWidget.Pivot.TopLeft;
		forceTxt.color = Color.New(41 / 255, 209 / 255, 69 / 255, 1);
		forceTxt.text = LanUtil.formateStr(LanUtil.getValue(110548), tostring(force))
	end

	for i = 1, data.addAttrList:getSize() do
		local attrTxt = UICreate.createLabel(self.content, "", -172, 0, 235, 22, 22);
		attrTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
		attrTxt.pivot = UIWidget.Pivot.TopLeft;
		attrTxt.color = Color.New(41 / 255, 209 / 255, 69 / 255, 1);
		local attr = data.addAttrList[i].value;
		if data.addAttrList[i].show_percent == 1 then
			attrTxt.uiwidget.text = attr .. data.addAttrList[i].attrStr;
		else
			attrTxt.uiwidget.text = attr .. LanUtil.getValue(110527) .. data.addAttrList[i].attrStr;
		end
		attrTxtArr:add(attrTxt);
	end
	for i = 1, attrTxtArr:getSize() do
		if i == 1 then
			attrTxtArr[i]:setLocation(-172, 65 - forceTxt.height - 8);
		else
			attrTxtArr[i]:setLocation(-172, attrTxtArr[i - 1].mainContent.transform.localPosition.y - attrTxtArr[i - 1].height - 8);
		end
	end
end

function Lua_PetPanaceaDetailPanel:getHeight()
	return self.height;
end