Lua_PetSkillDetailWindow = class("Lua_PetSkillDetailWindow", Lua_Window);
function Lua_PetSkillDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_PetSkillDetailWindow";
	self.skinName = "PetSkillDetailWindow_skin";
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_PetSkillDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.actvCondTxt:setEnable(true);
	self.activatedObj:SetActive(false);

	self.skillDesBg.clickScale = false;
	self.skillDesBg:addClickFuntion(self, self.onSkillDesBgBtn);
	self.levleUpBtn:addClickFuntion(self, self.onLevleUpBtnBtn);
	self.itemNameTxt:addClickFuntion(self, self.onItemNameTxtBtn);

	self:addLuaEvent("SERVANT_SKILL_PANEL_UPDATE", self, self.updatePanel);
	self:addLuaEvent("PACK_UPDATE", self, self.updatePanel);
end

function Lua_PetSkillDetailWindow:showWin(param)
	self:superCall("showWin", param);

	self.skillNameTxt.uiwidget.text = string.format("%s Lv.%d", param.skillName, param.skillLvl);
	self.skillCDTxt.uiwidget.text = LanUtil.formateStr(LanUtil.getValue(110524), tostring(param.coolTime));

	self.skill:setAltas(param.atlasName, param.iconName);

	if param.skillType == 5 then
		self.skillTypeTxt.uiwidget.text = LanUtil.getValue(110600);
	elseif param.skillType == 4 then
		self.skillTypeTxt.uiwidget.text = LanUtil.getValue(110601);
	else
		self.skillTypeTxt.mainContent:SetActive(false);
	end

	if param.isActivated then
		self.actvCondTxt:setEnable(false);
		self.activatedObj:SetActive(true);

		self.itemInfo = param.skillLvlUpItemInfo
		local itemInfo = param.skillLvlUpItemInfo;
		local itemNum = DataCenter.packData:getBagType(2):getItemNum(itemInfo.itemId);
		local itemNumStr;
		if itemNum >= itemInfo.needNum then
			itemNumStr = itemNum;
			self.levleUpBtn:setBtnEnable(true);
		else
			itemNumStr = "[D9000E]" .. itemNum .. "[-]";
			self.levleUpBtn:setBtnEnable(false);
		end
		self.itemNameTxt.text = "[D900D6]" .. itemInfo.name;
		self.qohTxt.text = itemNumStr .. "/" .. itemInfo.needNum;

		self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(-17, -22, 335, 188));
	else
		self.actvCondTxt:setEnable(true);
		self.activatedObj:SetActive(false);
		self:setActvCondTxt();

		self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(-17, -36, 335, 217));
	end
	self.dragContainer:setLocation(0, 26, 0);

	self.curEffect = Lua_PetSkillDesPanel.new(self.dragContainer);
	self.curEffect:updataDesText(param);
	self.dragContainer.addNum = 20;
	self.dragContainer:updateChildPos();
end

function Lua_PetSkillDetailWindow:updatePanel()
	self.skillNameTxt.text = string.format("%s Lv.%d", self.showData.skillName, self.showData.skillLvl);

	local itemInfo = self.showData.skillLvlUpItemInfo;
	local itemNum = DataCenter.packData:getBagType(2):getItemNum(itemInfo.itemId);
	local itemNumStr;
	if itemNum >= itemInfo.needNum then
		itemNumStr = itemNum;
		self.levleUpBtn:setBtnEnable(true);
	else
		itemNumStr = "[D9000E]" .. itemNum .. "[-]";
		self.levleUpBtn:setBtnEnable(false);
	end
	self.itemNameTxt.uiwidget.text = "[D900D6]" .. itemInfo.name;
	self.qohTxt.uiwidget.text = itemNumStr .. "/" .. itemInfo.needNum;

	Lua_MsgUtil.callFunc("UPDATE_PET_PANEL_RED_DOT");
end

function Lua_PetSkillDetailWindow:onSkillDesBgBtn()
end

function Lua_PetSkillDetailWindow:onLevleUpBtnBtn()
	self.showData.commonData:sSkillLvlUp(self.showData.skillId);
end

function Lua_PetSkillDetailWindow:onItemNameTxtBtn(go)
	local tvo = Lua_ToolVo.new(self.itemInfo.itemId);
	Lua_PackUtil.showItemInfo(tvo);
end

function Lua_PetSkillDetailWindow:setActvCondTxt()
	local stage = math.floor(self.showData.useLvl / 10) + 1;
	local numStr = string.split(LanUtil.getValue(110507), ",");
	local words = string.split(LanUtil.getValue(110508), ",");
	self.actvCondTxt.text = numStr[stage + 1] .. words[1] .. words[3];
end





--------------------------------------------------





Lua_PetSkillDesPanel = class("Lua_PetSkillDesPanel", Lua_DragContainerItem);
function Lua_PetSkillDesPanel:ctor(dragContainer, height)
	self.height = height == nil and 54.8 or height;
	self.dragContainer = dragContainer;
	self:superCall("ctor", dragContainer.sub, "PetSkillDesPanel_skin");
	dragContainer:addSubContainer(self, true);
end

function Lua_PetSkillDesPanel:updataDesText(data)
	self._data = data;

	local percent1 = "[dfa33b]" .. data:getDetailEffect(data.skillLvl);
	self.desTxt1.uiwidget.text = LanUtil.formateStr(data.desText, tostring(percent1));
	local percent2 = data:getDetailEffect(data.skillLvl + 1);
	if percent2 == nil then
		self.desTxt2.uiwidget.text = "[b1caf4]" .. LanUtil.getValue(110526);
	else
		percent2 = "[29d145]" .. percent2;
		self.desTxt2.uiwidget.text = LanUtil.formateStr(data.desText, tostring(percent2));
	end
	if self.desTxt2.height <= 20 then
		self.dragContainer.canDrag = false;
	else
		self.dragContainer.canDrag = true;
	end
	local dis1 = 17.8;
	local dis2 = 22.7;
	local desObjHeight1 = self.desTitleBg1.height + dis1 + self.desTxt1.height;
	local desObjHeight2 = self.desTitleBg2.height + dis1 + self.desTxt2.height;

	local desObj2PosX = self.desObj2.transform.localPosition.x;
	local desObj2PosY = self.desObj1.transform.localPosition.y - desObjHeight1 - dis2;
	LuaUtil.setObjPos(self.desObj2, desObj2PosX, desObj2PosY, 0);

	self.height = desObjHeight1 + desObjHeight2 + dis2 + 23;
end

function Lua_PetSkillDesPanel:getHeight()
	return self.height;
end

function Lua_PetSkillDesPanel:dispose()
	self:superCall("dispose");
end