-- 骑装合成Panel
Lua_MountEquipCompoundPanel  = class("Lua_MountEquipCompoundPanel", Lua_DisplayObject);
function Lua_MountEquipCompoundPanel:ctor(p)	
	self:superCall("ctor", p,"MountEquipCompounPanel_skin");
end

function Lua_MountEquipCompoundPanel:buildShowItem()
	self:superCall("buildShowItem");

	local posTable = {{-80, 49}, {-80, -77}, {-80, 175}};
	local itemImg;
	self.materlsArr = Array();
	for i = 1, #posTable do
		itemImg = Lua_ToolImage.new(self.content);
		itemImg:setLocation(posTable[i][1], posTable[i][2], 0);
		itemImg:setDepth(6);
		self.materlsArr:add(itemImg);
	end

	local addImagePos = {{340, 49}, {340, -77}, {340, 175}};
	self.addsArr = Array();
	for i = 1, #addImagePos do
		itemImg = Lua_ToolImage.new(self.content);
		itemImg:setLocation(addImagePos[i][1], addImagePos[i][2], 0);
		itemImg:setDepth(5);
		self.addsArr:add(itemImg);
	end

	self.mainImage = Lua_ToolImage.new(self.content);
	self.mainImage:setDepth(7);
	self.mainImage:removeFun(false);
	self.mainImage.item_bg:addClickFuntion(self, self.onMountIconClick);
	self.mainImage:setLocation(134, 47, 0);

	self.oneBtn:addClickFuntion(self, self.onOneClick);
	self.combineBtn:addClickFuntion(self, self.onCombineClick);
	self.rightAddSp1:addClickFuntion(self, self.onAddClick1);
	self.rightAddSp2:addClickFuntion(self, self.onAddClick2);
	self.rightAddSp3:addClickFuntion(self, self.onAddClick3);
	self.addItemSp1:addClickFuntion(self, self.onAddItemClick1);
	self.addItemSp2:addClickFuntion(self, self.onAddItemClick2);
	self.addItemSp3:addClickFuntion(self, self.onAddItemClick3);

	self:addLuaEvent("REMOVE_RATE_ITEM_1", self, self.onRemoveRateItem1);
	self:addLuaEvent("REMOVE_RATE_ITEM_2", self, self.onRemoveRateItem2);
	self:addLuaEvent("REMOVE_RATE_ITEM_3", self, self.onRemoveRateItem3);
	self:addLuaEvent("REMOVE_NEED_ITEM_1", self, self.onRemoveNeedItem1);
	self:addLuaEvent("REMOVE_NEED_ITEM_2", self, self.onRemoveNeedItem2);
	self:addLuaEvent("REMOVE_NEED_ITEM_3", self, self.onRemoveNeedItem3);
	self:addLuaEvent("RATE_ITEM_SELECTED", self, self.onRateItemSelected);
	self:addLuaEvent("NEED_ITEM_SELECTED", self, self.onNeedItemSelected);
end

function Lua_MountEquipCompoundPanel:onAddItemClick1(go)
	self:showAddItem(1);
end

function Lua_MountEquipCompoundPanel:onAddItemClick2(go)
	self:showAddItem(2);
end

function Lua_MountEquipCompoundPanel:onAddItemClick3(go)
	self:showAddItem(3);
end

function Lua_MountEquipCompoundPanel:showAddItem(val)
	local list = self.data:getBagEquList(self.putUpItem);
	if list:getSize() > 0 then -- 选择背包里面的道具
		Lua_WindowUtil.openWin("Lua_ItemSelectedWindow", nil, {index=val, list=list, isEquip=true});
	else -- 弹出获取途径
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, self.data.materials)
	end
end

function Lua_MountEquipCompoundPanel:onAddClick1(go)
	self:showAddClick(1);
end

function Lua_MountEquipCompoundPanel:onAddClick2(go)
	self:showAddClick(2);
end

function Lua_MountEquipCompoundPanel:onAddClick3(go)
	self:showAddClick(3);
end

function Lua_MountEquipCompoundPanel:showAddClick(val)
	local isItem = self.data:isHaveItem(self.addRateItems);
	local itemId = self.data.showRateItem[1].id;
	local packNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(itemId);
	if isItem == true or packNum <= 0 then--弹出获取途径
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, self.data.showRateItem);
	else
		Lua_WindowUtil.openWin("Lua_ItemSelectedWindow", nil, 
			{index=val, list=self.addRateItems, data=self.data, success=self.addRate,
			maxSucRate=self.maxSucRate, isEquip=false, isSameItemId = true});
	end
end

function Lua_MountEquipCompoundPanel:onRateItemSelected(o)
	self.addRateItems[o.index] = o.itemId;
	self:updateAddRateItem();
end

function Lua_MountEquipCompoundPanel:onNeedItemSelected(o)
	self.putUpItem[o.index] = o.data;
	self:updateMaterials();
end

function Lua_MountEquipCompoundPanel:onRemoveRateItem1(o)
	self.addRateItems[1] = 0;
	self:updateAddRateItem();
end

function Lua_MountEquipCompoundPanel:onRemoveRateItem2(o)
	self.addRateItems[2] = 0;
	self:updateAddRateItem();
end

function Lua_MountEquipCompoundPanel:onRemoveRateItem3(o)
	self.addRateItems[3] = 0;
	self:updateAddRateItem();
end

function Lua_MountEquipCompoundPanel:onRemoveNeedItem1(o)
	self.putUpItem[1] = nil;
	self:updateMaterials();
end

function Lua_MountEquipCompoundPanel:onRemoveNeedItem2(o)
	self.putUpItem[2] = nil;
	self:updateMaterials();
end

function Lua_MountEquipCompoundPanel:onRemoveNeedItem3(o)
	self.putUpItem[3] = nil;
	self:updateMaterials();
end

function Lua_MountEquipCompoundPanel:setData(val)
	self.data = val;

	self.need_item_num = val.need_item_num;

	self.tvo = Lua_ToolVo.createToolVo(val.id);
	self.tvo.darkColor = true;
	self.mainImage.data = self.tvo;

	local materials = val:getBagEquList();
	self.putUpItem = {}; -- 放在融科框的道具
	self.putUpItem[1] = materials[1];
	self.putUpItem[2] = materials[2];
	self.putUpItem[3] = materials[3];

	self:updateMaterials();

	self.maxSucRate = self.data.getMaxSucRate; -- 成功率上限制
	local addTxt = {self.rightAddSp1, self.rightAddSp2, self.rightAddSp3}
	if self.maxSucRate ~= nil then
		for i,v in ipairs(addTxt) do
			addTxt[i]:setEnable(true)
		end
		self.addRateItems = {0,0,0};
		self:updateAddRateItem();
	else
		for i = 1, self.addsArr:getSize() do
			addTxt[i]:setEnable(false);

			self.addsArr[i].data = nil;
			self.addsArr[i]:showLockSlot(true);
			self.addsArr[i]:setCanClick(false);
		end
		self.successTxt.text = LanUtil.formateStr(LanUtil.getValue(110827), tostring(self.data.rate));
	end
	self:showRedDot(self.data.isShowCompoundRed) -- 红点显示
end

function Lua_MountEquipCompoundPanel:updateMaterials()
	for i = 1, self.need_item_num do
		if i <= self.need_item_num then
			if self.putUpItem[i] == nil then -- 不够装备
				self.materlsArr[i].data = nil;
				self.materlsArr[i]:showCloseSp(false, false, "REMOVE_NEED_ITEM_"..i, "b");

				self["addItemSp"..i]:setEnable(true);
			else
				local tvo = Lua_ToolVo.createToolVo(self.putUpItem[i].id,self.putUpItem[i].amount,self.putUpItem[i].bind);
				-- tvo:fromServer(self.putUpItem[i]);
				tvo.isShowBtn = false;
				tvo.equipment = self.putUpItem[i].equipment;
				tvo.packType = Lua_PackData.BAG_PACK;

				self.materlsArr[i].data = tvo;
				self.materlsArr[i]:showLockSlot(false);
				self.materlsArr[i]:showCloseSp(true, true, "REMOVE_NEED_ITEM_"..i, "b");

				self["addItemSp"..i]:setEnable(false);
			end
		else
			self.materlsArr[i].data = nil;
			self.materlsArr[i]:showLockSlot(true);
			self.materlsArr[i]:showCloseSp(false);

			self["addItemSp"..i]:setEnable(false);
			self.putUpItem[i] = nil;
		end
	end
end

function Lua_MountEquipCompoundPanel:updateAddRateItem()
	if self.data == nil then
		return;
	end

	local numDic = {};
	for k,v in pairs(self.addRateItems) do
		if numDic[v] == nil then
			numDic[v] = 0;
		end
		numDic[v] = numDic[v] + 1;
	end

	local hasItem = false;
	local rateItems = self.data.rateItem;
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	for i = 1, rateItems:getSize() do
		local n = bagData:getItemNum(rateItems[i].itemId);
		local useNum = numDic[rateItems[i].itemId] == nil and 0 or numDic[rateItems[i].itemId];
		if n > useNum then
			hasItem = true;
			break;
		end
	end

	local addRate = 0;
	for i = 1, self.need_item_num do
		if self.addRateItems[i] == 0 then
			self.addsArr[i].data = nil;
			self.addsArr[i]:showCloseSp(false, false, "REMOVE_RATE_ITEM_"..i, "a");
			self["rightAddSp"..i]:setEnable(true);
			self.addsArr[i]:setCanClick(false);
		else
			local tvo = Lua_ToolVo.createToolVo(self.addRateItems[i]);
			self.addsArr[i].data = tvo;
			self.addsArr[i]:showCloseSp(true, true, "REMOVE_RATE_ITEM_"..i, "a");
			self["rightAddSp"..i]:setEnable(false);
			self.addsArr[i]:setCanClick(true);
		end
	end

	self.addRate = self.data:getRateItemRate(self.addRateItems) + self.data.rate;
	if self.addRate > 100 then
		self.addRate = 100;
	end
	self.successTxt.text = LanUtil.formateStr(LanUtil.getValue(110827), tostring(self.addRate));
end

function Lua_MountEquipCompoundPanel:onOneClick(go)
	if self.maxSucRate == nil then
		return
	end
	if self.data:isHaveItem(self.addRateItems) == true then
		return
	end
	if self.addRate == self.maxSucRate then
		OperateAlert.show(LanUtil.getValue(110735));
		return
	end

	local len = self.data:getMountItemLen(self.addRateItems);
	local rate = self.data.rate + self.data:getRateItemRate(self.addRateItems);
	local putItem = {};
	local rateItem = self.data.rateItem;
	for i = 1, rateItem:getSize() do
		local hasItem = false;
		for j=1,rateItem:getSize() do
			local packNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(rateItem[j].itemId);
			local useNum = putItem[rateItem[j].itemId] == nil and 0 or putItem[rateItem[j].itemId];
			if packNum > useNum  then
				self.addRateItems[i] = rateItem[j].itemId;
				hasItem = true;
				if packNum > len and self.addRateItems[3] ~= 0 and self.addRate >= self.maxSucRate then
					hasItem = false;
				end

				if putItem[rateItem[j].itemId] == nil then
					putItem[rateItem[j].itemId] = 1;
				else
					putItem[rateItem[j].itemId] = putItem[rateItem[j].itemId] + 1;
				end
				break;
			end
		end

		if hasItem == false or rate >= 100 then
			break;
		end
	end
	self:updateAddRateItem();
end

function Lua_MountEquipCompoundPanel:onMountIconClick()
	if self.tvo ~= nil then
		Lua_PackUtil.showItemInfo(self.tvo, false, nil, false);
	end
end

function Lua_MountEquipCompoundPanel:onCombineClick(go)
	self.equipIndex = DataCenter.mountEquipData:getPackEquipList(self.putUpItem);
	if self.equipIndex:getSize() == self.need_item_num then
		if self.maxSucRate ~= nil then
			if self.addRate < self.maxSucRate then
				self:showTipPanel();
			else
				self:onAffirmCombineClick();
			end
		else
			self:onAffirmCombineClick();
		end
	else
		OperateAlert.show(LanUtil.getValue(110748));
	end
end

function Lua_MountEquipCompoundPanel:showTipPanel()
	local tipData = {};
	tipData.des = LanUtil.formateStr(LanUtil.getValue(110749), tostring(self.addRate), tostring(self.maxSucRate));
	tipData.owner = self;
	tipData.type = 1;
	tipData.txtPivot = UIWidget.Pivot.Left;
	tipData.txtFontSize = 26;
	tipData.txtSpacingY = 10;
	tipData.subName = LanUtil.getValue(110739);
	tipData.subFun = self.onAffirmCombineClick;
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_MountEquipCompoundPanel:onAffirmCombineClick()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	local itemIndex;
	if self.maxSucRate ~= nil then
		itemIndex = DataCenter.mountEquipData:getPackItemList(self.addRateItems);
	else
		itemIndex = nil;
	end
	Lua_ProxyManager.getProxy("Lua_MountProxy"):sCompoundMountEquip(self.data.id, self.equipIndex, itemIndex);
end

function Lua_MountEquipCompoundPanel:showRedDot(val)
	if val then
		if self._redDot == nil then
			self._redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 75, -190, 0, 0);
			self._redDot:setDepth(10);
			self._redDot.name = "redDot";
		end
		self._redDot:setEnable(true);
	else
		if self._redDot ~= nil then
			self._redDot:setEnable(false);
		end
	end
end