-- 骑装合成
checkRequire("Lua_MountEquipCompoundPanel");
Lua_MountEquipCompoundWindow = class("Lua_MountEquipCompoundWindow", Lua_SecondSizeWindow);
function Lua_MountEquipCompoundWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MountEquipCompoundWindow";
	self.skinName = "MountEquipCompoundWindow_skin";
	self.titleText = LanUtil.getValue(110745);
end

function Lua_MountEquipCompoundWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.compoundPanel = Lua_MountEquipCompoundPanel.new(self.content);

	local arr = DataCenter.mountEquipUtil.getMountCalssInfo;
	self.btnList = Lua_DragSubButtonList.new(self.content, 1, Vector4(0, 0, 192, 546),
		Vector3(192, 66, 0), Vector3(184, 46, 0), Vector2(0, 0), Vector3(0, 16));
	self.btnList:setLocation(-440, -35, 0);
	self.btnList:setDepth(5);
	self.btnList:setMainBtnStyle("common_atlas_1", "ui_common_btn_01", "ui_common_btn_02", "D5DADE", "FFFFFF", 28);
	self.btnList:setSubBtnStyle("common_atlas_1", "ui_common_btn_p4", "ui_common_btn_p3", "92A0DA", "FFFCB7", 26);
	self.btnList:setData(arr, self, self.onButtonListClick, 0, 240); -- (546 - 66) / 2
	self.btnList:setMainSlected(1, 1);
	self.btnList.clickDrawBack = true;

	self.helpLab.text = LanUtil.getValue(110744);
	self.help:addClickFuntion(self, self.onRuleClick); -- 问号

	self:updateShowRodDataList();
	
	self:addLuaEvent("PACK_MOUNTEQUIP_UPDATE", self, self.onItemChange);
	self:addLuaEvent("UPDATE_COMPOUND_PANEL", self, self.onItemChange);
	self:addLuaEvent("UPDATE_COMPOUND_EFFECT", self, self.showEffect);
end

function Lua_MountEquipCompoundWindow:showWin(param)
	self:superCall("showWin", param);
	
	local index = DataCenter.mountEquipUtil:getCompoundclassId(self.showData.vo.id);
	if index == nil then
		index = 1;
	end
	self.btnList:setMainSlected(index, 1, false);
end

function Lua_MountEquipCompoundWindow:onButtonListClick(data)
	self.selectedData = data;
	DataCenter.mountEquipUtil.selectItemData = data.data;
	
	self.compoundPanel:setData(data.data);
	self:updateShowRodDataList();
end

function Lua_MountEquipCompoundWindow:onItemChange()
	if self.selectedData.data ~= nil then
		self.compoundPanel:setData(self.selectedData.data);
		self:updateShowRodDataList();
	end
end

function Lua_MountEquipCompoundWindow:showEffect(val) -- 1成功，0失败
	if self.rsEffect ~= nil then
		self.rsEffect:dispose();
		self.rsEffect = nil;
	end

	if val then
		self.rsEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_hechengchenggong", "gui_hechengchenggong", 117, 15);
	else
		self.rsEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_hechengshibai", "gui_hechengshibai", 117, 15);
	end
	self.rsEffect:SetRenderQueue(self.fengxian, 100, 2, false);
end

function Lua_MountEquipCompoundWindow:updateShowRodDataList()
	local info = DataCenter.mountEquipUtil.mountCalssInfo;
	local list;
	local redList = {}
    for k,v in pairs(info) do
        list = DataCenter.mountEquipUtil:updateShowClassList(k);
        for i,j in pairs(list) do
        	redList[k] = j;
        end
    end
    self.btnList:setRedDot(1, redList);

    self:updateShowRed();
end

function Lua_MountEquipCompoundWindow:updateShowRed()
	if self.selectedData == nil then
		return;
	end

	local info = DataCenter.mountEquipUtil.mountCalssInfo;
	local list;
	local redList = {}
    for k,v in pairs(info) do
        list = DataCenter.mountEquipUtil:updateShowGroupList(k);
        if v.mount_group_list ~= nil then
        	redList[k] = {};
        	for i,j in pairs(v.mount_group_list) do
        		redList[k][i] = list[j];
        	end
	    end
    end
    self.btnList:setRedDot(2, redList[self.selectedData.mainIndex]);
end

function Lua_MountEquipCompoundWindow:onRuleClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(110747));
end