-- 骑装强化
Lua_MountEquipIntensifyWindow = class("Lua_MountEquipIntensifyWindow", Lua_SecondSizeWindow);
function Lua_MountEquipIntensifyWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MountEquipIntensifyWindow";
	self.skinName = "MountEquipIntensifyWindow_skin";
	self.titleText = LanUtil.getValue(110752);
end

function Lua_MountEquipIntensifyWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("REMOVE_NEED_ITEM_1", self, self.onRemoveNeedItem1);
	self:addLuaEvent("REMOVE_NEED_ITEM_2", self, self.onRemoveNeedItem2);
	self:addLuaEvent("NEED_ITEM_SELECTED", self, self.onNeedItemSelected);

	self.isAutomatic = true;

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 360, 555));
	self.dragList:setListCell(Lua_MountEquipIntensifyItem, 113, 360, 1);
	self.dragList:setLocation(-374, -50, 0);

	self.leftImage = Lua_ToolImage.new(self.content);
	self.leftImage:setDepth(10);
	self.leftImage:setLocation(16, 95.5, 0);

	self.centerImage = Lua_ToolImage.new(self.content);
	self.centerImage:setDepth(10);
	self.centerImage:setLocation(200, 93, 0);

	local itemImg;
	local pos = {{360, 21.5}, {360, 166.5}};
	self.materlsArr = Array();
	for i = 1, #pos do
		itemImg = Lua_ToolImage.new(self.content);
		itemImg:setLocation(pos[i][1], pos[i][2], 0);
		itemImg:setDepth(8);
		self.materlsArr:add(itemImg);
	end

	self.autoBtn:addClickFuntion(self, self.onMountAutoClick);
	self.subBtn:addClickFuntion(self, self.onMountSubClick);
	self.addSp1:addClickFuntion(self, self.onAddItemClick1);
	self.addSp2:addClickFuntion(self, self.onAddItemClick2);

	self:updatePanelInfo();

	self:addLuaEvent("onIntensifyCellClick", self, self.updatePanelInfo);
	self:addLuaEvent("PACK_MOUNTEQUIP_UPDATE", self, self.updatePanelInfo);
	self:addLuaEvent("UPDATE_INTENS_PANEL", self, self.updatePanelInfo); -- 更新数据
	self:addLuaEvent("UPDATE_INTENS_PANEL", self, self.onSuccessEvent); -- 特效
end

function Lua_MountEquipIntensifyWindow:updatePanelInfo()
	local arr = DataCenter.mountEquipData:getMountEquipIntensifyData();
	self.dragList:setLuaArrayData(arr, false);

	self.length = self.dragList.showList:getSize();
	local index = DataCenter.mountEquipData.mountEquipPartInedx;
	if self.length ~= 0 then
		self.dragList:setSelected(index);
		-- self.dragList.showList[index]:onPlayerSoundClick();

		self:updateRightPanelInfo(arr[index].vo);
	end
end


function Lua_MountEquipIntensifyWindow:updateRightPanelInfo(val)
	if val == nil then
		return;
	end
	self.data = val;

	local tvo1 = Lua_ToolVo.createToolVo(val.item_id,val.amount,val.bind);
	tvo1:fromServer(val.data.item);
	tvo1.isShowBtn = false;
	tvo1.intensify_lvl = val.intensify_lvl;
	tvo1.mountPart = val.part;
	tvo1.max_intensify_lvl = val.max_level;
	self.leftImage.data = tvo1;

	local lvl = val.intensify_lvl < val.max_level and val.intensify_lvl + 1 or val.intensify_lvl;
	local tvo2 = Lua_ToolVo.createToolVo(val.item_id,val.amount,val.bind);
	tvo2:fromServer(val.data.item);
	tvo2.isShowBtn = false;
	tvo2.max_intensify_lvl = val.max_level;
	tvo2.intensify_lvl = lvl;
	tvo2.mountPart = val.part;
	self.centerImage.data = tvo2;

	self.left_txt.text = "Lv."..val.intensify_lvl;
	self.centre_txt.text = "Lv."..lvl;
	self.value.text = val.intensifyProp;
	self.add.text = val.nextIntensifyProp;

	if val.intensify_lvl < val.max_level then -- 未满级
		self.value:setLocation(64, -133, 0);

		self.desObj:SetActive(true);
		self.autoBtn:setBtnEnable(true);
		self.subBtn:setBtnEnable(true);
		self:updateRightItemInfo(); -- 右侧材料数据
	else -- 已满级
		self.value:setLocation(140, -133, 0);

		self.desObj:SetActive(false);
		self.autoBtn:setBtnEnable(false);
		self.subBtn:setBtnEnable(false);
		for i = 1, self.materlsArr:getSize() do
			self.materlsArr[i].data = nil;
			self.materlsArr[i]:showLockSlot(true);
			self.materlsArr[i]:showCloseSp(false);
			self.materlsArr[i]:setCanClick(false);

			self["addSp"..i]:setEnable(false);
			self["rightTxt"..i]:setEnable(false);
		end
	end
	self.redRot:setEnable(val.isShowIconRed);

	if DataCenter.mountEquipData.isAutomatic == false then -- 移除自动强化计时器
		self.isAutomatic = false;
		self:onMountAutoClick();
	end
end

function Lua_MountEquipIntensifyWindow:updateRightItemInfo()
	self.need_arr = self.data.needItemData; -- 材料数据
	self.isBreakLimit = self.data.isBreakLimit; -- 突破界限数据
	if self.isBreakLimit == 0 then -- 未突破极限道具
		for i=1 , 2 do--道具赋值
			if self.need_arr[i] ~= nil then
				local packNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.need_arr[i].id);
				local needNum = self.need_arr[i].num;
				local tvo = Lua_ToolVo.createToolVo(self.need_arr[i].id);
				self.materlsArr[i].data = tvo;
				self.materlsArr[i]:showLockSlot(false);
				self.materlsArr[i]:setCanClick(true);

				if packNum >= needNum then -- 灵纹精华显示
					self["rightTxt"..i].text = "[00E125]" .. packNum .. "[-]" .. "/" .. needNum;
				else
					self["rightTxt"..i].text = "[ff1616]" .. packNum .. "[-]" .. "/" .. needNum;
				end
				self["addSp"..i]:setEnable(false);
				self["rightTxt"..i]:setEnable(true);
				self.redRot:setEnable(packNum >= needNum);
			else
				self.materlsArr[i].data = nil;
				self.materlsArr[i]:showLockSlot(true);
				self.materlsArr[i]:setCanClick(false);

				self["addSp"..i]:setEnable(false);
				self["rightTxt"..i]:setEnable(false);
			end
			self.materlsArr[i]:showCloseSp(false);
		end
	else -- 突破极限道具
		local materials = self.data:getBagEquList();
		self.putUpItem = {}; -- 放入晋升的道具
		self.putUpItem[1] = materials[1];
		self.putUpItem[2] = materials[2];
		self:updateMaterials();
	end
end

-- 选择
function Lua_MountEquipIntensifyWindow:onNeedItemSelected(o)
    self.putUpItem[o.index] = o.data;
    self:updateMaterials();
end

-- 移除
function Lua_MountEquipIntensifyWindow:onRemoveNeedItem1(o)
    self.putUpItem[1] = nil;
    self:updateMaterials();
end

-- 移除
function Lua_MountEquipIntensifyWindow:onRemoveNeedItem2(o)
    self.putUpItem[2] = nil;
    self:updateMaterials();
end

-- 更新道具信息
function Lua_MountEquipIntensifyWindow:updateMaterials()
	for i = 1, 2 do
		if i <= self.need_arr:getSize() then
			local num = self.need_arr[i].num;
			if self.putUpItem[i] == nil then -- 不够装备
				self.materlsArr[i].data = nil;
				self.materlsArr[i]:showLockSlot(false);
				self.materlsArr[i]:setCanClick(true);
				self.materlsArr[i]:showCloseSp(false, false, "REMOVE_NEED_ITEM_"..i, "b");

				self["rightTxt"..i]:setEnable(true);
				self["addSp"..i]:setEnable(true)
				self["rightTxt"..i].text = "[ff1616]".. 0 .. "[-]".. "/" .. num;
			else
				local tvo = Lua_ToolVo.createToolVo(self.putUpItem[i].id, self.putUpItem[i].amount, self.putUpItem[i].bind);
				tvo.isShowBtn = false;
				tvo.equipment = self.putUpItem[i].equipment;
				tvo.packType = Lua_PackData.BAG_PACK;
				
				self.materlsArr[i].data = tvo;
				self.materlsArr[i]:showLockSlot(false);
				self.materlsArr[i]:setCanClick(true);
				self.materlsArr[i]:showCloseSp(true, true, "REMOVE_NEED_ITEM_"..i, "b");

				self["rightTxt"..i]:setEnable(true);
				self["addSp"..i]:setEnable(false);
				self["rightTxt"..i].text = "[00E125]" .. num .. "[-]" .. "/" .. num;
			end
		else
			self.materlsArr[i].data = nil;
			self.materlsArr[i]:showLockSlot(true);
			self.materlsArr[i]:setCanClick(false);
			self.materlsArr[i]:showCloseSp(false);

			self.putUpItem[i] = nil;
			self["rightTxt"..i]:setEnable(false);
			self["addSp"..i]:setEnable(false)
		end
	end
end

function Lua_MountEquipIntensifyWindow:onAddItemClick1(go)
	self:showAddItem(1);
end

function Lua_MountEquipIntensifyWindow:onAddItemClick2(go)
	self:showAddItem(2);
end

function Lua_MountEquipIntensifyWindow:showAddItem(val)
	local list = self.data:getBagEquList(self.putUpItem);
	if list:getSize() > 0 then -- 选择背包里面的道具
		Lua_WindowUtil.openWin("Lua_ItemSelectedWindow", nil, {index = val, list = list, isEquip = true});
	else -- 弹出获取途径
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, self.data.materials)
	end
end

-- 自动强化
function Lua_MountEquipIntensifyWindow:onMountAutoClick(go)
	if self.isAutomatic == true then
		DataCenter.mountEquipData.isAutomatic = self.isAutomatic;

		self.autoBtn.label = LanUtil.getValue(126001);
		self.subBtn:removeClickFuntion(self, self.onMountSubClick);

		self.isAutomatic = false;
		Lua_CommonUtil.addTimer("auto_Timer", 0.5, self, self.onMountSubClick);
	else
		self.autoBtn.label = LanUtil.getValue(126000);
		self.subBtn:addClickFuntion(self, self.onMountSubClick);

		self.isAutomatic = true;
		Lua_CommonUtil.removeTimer(self, self.onMountSubClick);
	end
end

-- 强化
function Lua_MountEquipIntensifyWindow:onMountSubClick(go)
	if self.isBreakLimit == 0 then
		local packNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.need_arr[1].id);
		local needNum = self.need_arr[1].num;
		if packNum >= needNum then
			self:onAffirmCombineClick();
		else
			Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, self.data.materials)
			self.isAutomatic = false;
			self:onMountAutoClick(); -- 自动强化
			return;
		end
	else
		self.equipIndex = DataCenter.mountEquipData:getPackEquipList(self.putUpItem)
		if self.equipIndex:getSize() >= self.need_arr:getSize() then
			self:onAffirmCombineClick();
		else
			Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, self.data.materials)
			self.isAutomatic = false;
			self:onMountAutoClick(); -- 自动强化
			return;
		end
	end
end

function Lua_MountEquipIntensifyWindow:onAffirmCombineClick()
	if self.isBreakLimit == 0 then
		Lua_ProxyManager.getProxy("Lua_MountProxy"):sIntensifyMountEquip(self.data.part, self.isBreakLimit);
	else
		Lua_ProxyManager.getProxy("Lua_MountProxy"):sIntensifyMountEquip(self.data.part, self.isBreakLimit, self.equipIndex);
	end
end

function Lua_MountEquipIntensifyWindow:onSuccessEvent()
	if self.effect == nil then
		self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_qianghua", "gui_qianghua", 187, 81);
		self.effect:SetRenderQueue(self.center_bg, 100, 2, false);
	else
		self.effect:setEnable(false);
		self.effect:setEnable(true);
	end

	if self.effect1 == nil then
		self.effect1 = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_qianghuaziti", "gui_qianghuaziti", 188, -83);
		self.effect1:SetRenderQueue(self.center_bg, 101, 2, false);
	else
		self.effect1:setEnable(false);
		self.effect1:setEnable(true);
	end
end

function Lua_MountEquipIntensifyWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onMountSubClick);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_MountEquipIntensifyItem = class("Lua_MountEquipIntensifyItem", Lua_ListCell);
function Lua_MountEquipIntensifyItem:ctor(p)
	self:superCall("ctor", p, "MountEquipIntensifyItem_skin");
end

function Lua_MountEquipIntensifyItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(-112, 0, 0);
end

function Lua_MountEquipIntensifyItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data.vo.item_id,data.vo.amount,data.vo.bind);
	tvo:fromServer(data.vo.data.item);
	tvo.isShowBtn = false;
	tvo.intensify_lvl = data.vo.intensify_lvl;
	tvo.max_intensify_lvl = data.vo.max_level;
	tvo.mountPart = data.vo.part;

	self.itemImg.data = tvo;
	self.itemTxt.text = data.vo.name;
	self.redRot:setEnable(data.vo.isShowIconRed);
end

function Lua_MountEquipIntensifyItem:onPlayerSoundClick(go)
	DataCenter.mountEquipData.isAutomatic = false;
	DataCenter.mountEquipData.mountEquipPartInedx = DataCenter.mountEquipData:getMountEquipIndex(self._data.part);
	Lua_MsgUtil.callFunc("onIntensifyCellClick");
end

function Lua_MountEquipIntensifyItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_p2");
		self.selectSp:setEnable(true);
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_p1");
		self.selectSp:setEnable(false);
	end
end

function Lua_MountEquipIntensifyItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end