Lua_ServantLvlUpItem = class("Lua_ServantLvlUpItem", Lua_ListCell);
function Lua_ServantLvlUpItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ServantLvlUpItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setCanClick(false);
	self.itemImg:setDepth(5);

	self.maskImg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_black_50", 0, 0, 76, 78);
	self.maskImg:setDepth(9);

	self.tickImg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_xz", 0, 0, 0, 0);
	self.tickImg:setDepth(10);
end

function Lua_ServantLvlUpItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.itemImg.data = data.voData;
	self.itemImg:showNewTip(false);
	self.maskImg:setEnable(data.isSelected);
	self.tickImg:setEnable(data.isSelected);
end

function Lua_ServantLvlUpItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("ITEM_CLICK", self.data);
end

function Lua_ServantLvlUpItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	if self.maskImg ~= nil then
		self.maskImg:dispose();
		self.maskImg = nil;
	end
	if self.tickImg ~= nil then
		self.tickImg:dispose();
		self.tickImg = nil;
	end
	self.data = nil;

    self:superCall("dispose");
end