checkRequire("Lua_ServantLvlUpItem");
Lua_ServantLvlUpWindow = class("Lua_ServantLvlUpWindow", Lua_SecondSizeWindow);
function Lua_ServantLvlUpWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ServantLvlUpWindow";
	self.titleText = LanUtil.getValue(110513);
end

function Lua_ServantLvlUpWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.servantLvlUpPanel = Lua_ServantLvlUpPanel.new(self.content);
end

function Lua_ServantLvlUpWindow:dispose()
	if self.servantLvlUpPanel ~= nil then
		self.servantLvlUpPanel:dispose();
		self.servantLvlUpPanel = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_ServantLvlUpPanel = class("Lua_ServantLvlUpPanel", Lua_DisplayObject);
function Lua_ServantLvlUpPanel:ctor(p)
	self:superCall("ctor", p, "ServantLvlUpWindow_skin");
end

function Lua_ServantLvlUpPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.curDragDownIndex = 1;
	self.lvlUpData = DataCenter.servantLvlUpData;
	self.servantData = DataCenter.servantData;

	self.ruleTxtList = Array();
	self.ruleTxtList:add(self.ruleTxt1);
	self.ruleTxtList:add(self.ruleTxt2);
	self.ruleTxtList:add(self.ruleTxt3);

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 1030, 322));
	self.dragList:setLocation(0, 72.5, 0);
	self.dragList:setListCell(Lua_ServantLvlUpItem, 103, 103, 10);
	self.dragList:setDepth(3510);
	self.dragList.canDrag = true;

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 462, 104));
	self.dragContainer:setLocation(294, -176, 0);
	self.servantLvlUpAttrPanel = Lua_ServantLvlUpAttrPanel.new(self.content);
	self.dragContainer:addSubContainer(self.servantLvlUpAttrPanel, true);

	self.subBtn1:addClickFuntion(self, self.onSubBtnClick1);
	self.subBtn2:addClickFuntion(self, self.onSubBtnClick2);
	self.subBtn3:addClickFuntion(self, self.onSubBtnClick3);
	self.funBtn:addClickFuntion(self, self.onFunBtnClick);

	self:initSelectedIndexList();

	self:addLuaEvent("Servant_LVL_UP_UPDATE", self, self.updatePanel);
	self:addLuaEvent("DRAGDOWN_CLICK", self, self.dragDownClick);
	self:addLuaEvent("ITEM_CLICK", self, self.itemClick);

	DataCenter.servantLvlUpData:sGetLvlUpPanelInfo();
end

function Lua_ServantLvlUpPanel:initSelectedIndexList()
	local defaultIndex = self.lvlUpData.tempData.defaultIndex;
	local dragListLen = DataCenter.servantLvlUpData.tempData.dragListLen;
	self.dragDownList = Array();
	self.dragDownList:add({selectedIndex = defaultIndex[1], ruleTxt = self.ruleTxt1, len = dragListLen[1]});
	self.dragDownList:add({selectedIndex = defaultIndex[2], ruleTxt = self.ruleTxt2, len = dragListLen[2]});
	self.dragDownList:add({selectedIndex = defaultIndex[3], ruleTxt = self.ruleTxt3, len = dragListLen[3]});

	local colorStr = string.split(LanUtil.getValue(110517), ",");
	local color = string.split(LanUtil.getValue(110525), ",");
	if self.dragDownList[1].ruleTxtList == nil then
		local ruleTxtList = Array();
		for i = 3, 1, -1 do
			ruleTxtList:add(color[i] .. colorStr[i] .. "[-]" .. "[85A8BE]" .. LanUtil.getValue(110518));
		end
		ruleTxtList:add("[85A8BE]" .. LanUtil.getValue(110516));
		self.dragDownList[1].ruleTxtList = ruleTxtList;
	end

	local numStr = string.split(LanUtil.getValue(110507), ",");
	local str = string.split(LanUtil.getValue(110508), ",")[1];
	if self.dragDownList[2].ruleTxtList == nil then
		local ruleTxtList = Array();
		for i = 16, 3, -1 do
			ruleTxtList:add("[85A8BE]" .. numStr[i] .. str .. LanUtil.getValue(110518));
		end
		ruleTxtList:add("[85A8BE]" .. numStr[2] .. str .. LanUtil.getValue(110519));
		ruleTxtList:add("[85A8BE]" .. LanUtil.getValue(110520));
		ruleTxtList:add("[85A8BE]" .. LanUtil.getValue(110516));
		self.dragDownList[2].ruleTxtList = ruleTxtList;
	end

	str = string.split(LanUtil.getValue(110508), ",")[2];
	if self.dragDownList[3].ruleTxtList == nil then
		local ruleTxtList = Array();
		for i = 4, 2, -1 do
			ruleTxtList:add("[85A8BE]" .. numStr[i] .. str .. LanUtil.getValue(110518));
		end
		ruleTxtList:add("[85A8BE]" .. numStr[1] .. str .. LanUtil.getValue(110519));
		ruleTxtList:add("[85A8BE]" .. LanUtil.getValue(110516));
		self.dragDownList[3].ruleTxtList = ruleTxtList;
	end

	for i = 1, self.dragDownList:getSize() do
		self.dragDownList[i].ruleTxt.text = self.dragDownList[i].ruleTxtList[defaultIndex[i]];
	end
end

function Lua_ServantLvlUpPanel:updatePanel()
	if self.lvlUpData.servantLvl == nil then
		return;
	end

	if self.lvlBase == nil then
		self.lvlBase = self.lvlUpData.servantLvl;
	end

	local lvlUpData = self.lvlUpData;
	self.lvlTxt.text = "Lv." .. lvlUpData.servantLvl;

	self:updateItemList();

	local maxLvlExp;
	if lvlUpData.isMaxLvl == 1 then
		maxLvlExp = lvlUpData:getMaxExp();
		local beyondNum = lvlUpData.servantExp - maxLvlExp;
		if beyondNum > 0 then
			beyondNumText = LanUtil.getValue(110510);
		else
			beyondNumText = "";
		end
		self:setExpBarValue(maxLvlExp, maxLvlExp, LanUtil.formateStr(LanUtil.getValue(110509) .. beyondNumText, tostring(beyondNum)));
	elseif (lvlUpData.isMaxLvl == 0) then
		maxLvlExp = lvlUpData:getMaxExp(lvlUpData.servantLvl);
		self:setExpBarValue(lvlUpData.servantExp, maxLvlExp);
	end

	local curAttrArr = self.servantData.curAttrArr;
	local attrArr = Array();
	for i = 1, curAttrArr:getSize() do
		attrArr:add({curAttr = curAttrArr[i], addedAttrDic = lvlUpData:getAttr(self.lvlUpData.servantLvl)});
	end
	self.servantLvlUpAttrPanel:setData(attrArr);

	self.dragContainer.canDrag = self.servantLvlUpAttrPanel:getHeight() > 220;
	self.dragContainer:updateChildPos();
end

function Lua_ServantLvlUpPanel:updateItemList()
	self.itemList = self.lvlUpData:getItemList();

	local selectedIndex1 = self.dragDownList[1].len - self.dragDownList[1].selectedIndex + 1;
	self.selectedColor = selectedIndex1 == 1 and nil or selectedIndex1 + 1;

	local selectedIndex2 = self.dragDownList[2].len - self.dragDownList[2].selectedIndex + 1;
	self.selectedStage = selectedIndex2 == 1 and nil or selectedIndex2 - 2;

	local selectedIndex3 = self.dragDownList[3].len - self.dragDownList[3].selectedIndex + 1;
	self.selectedStar = selectedIndex3 == 1 and nil or selectedIndex3 - 2;

	self:reSelect();
end

function Lua_ServantLvlUpPanel:setExpBarValue(value, maxValue, txt)
	if txt == nil then
		self.expBar:setText(tostring(value) .. "/" .. tostring(maxValue));
	else
		self.expBar:setText(tostring(txt));
	end
	self.expBar:setMaxValue(maxValue);
	self.expBar:setValue(value);
end

function Lua_ServantLvlUpPanel:setAddingExpText(exp)
	self.addExp.text = "+" .. exp;

	local vipLvl = DataCenter.vipData.level;
	local vipRatio = vipLvl == 0 and 0 or self.lvlUpData:getVipRatio(vipLvl);
	local name = getConfig( { "vip_level", vipLvl, "view_name"})
	if getLanType() == 2 and tonumber(vipLvl) == 100 then
		-- name = "會員";
		self.vipBonus.text = LanUtil.formateStr("（會員+{1}%）", tostring(vipRatio));
	else
		self.vipBonus.text = LanUtil.formateStr(LanUtil.getValue(110515), name, tostring(vipRatio));
	end

	local posX = self.addExpLab.mainContent.transform.localPosition.x + self.addExpLab.width + 13;
	self.addExp:setLocation(posX, -194, 0);
	posX = self.addExp.mainContent.transform.localPosition.x + self.addExp.width + 11;
	self.vipBonus:setLocation(posX, -194, 0);
end

function Lua_ServantLvlUpPanel:calcExp()
	local totalExp = 0;
	for i = 1, self.itemList:getSize() do
		if self.itemList[i].isSelected then
			totalExp = totalExp + self.itemList[i].addExp;
		end
	end
	return totalExp;
end

function Lua_ServantLvlUpPanel:onSubBtnClick1(go)
	self.curDragDownIndex = 1;

	local colorStr = string.split(LanUtil.getValue(110517), ",");
	local color = string.split(LanUtil.getValue(110525), ",");
	local dragData = {};
	dragData.datas = Array();
	for i = 3, 1, -1 do
		dragData.datas:add(color[i] .. colorStr[i] .. "[-][85A8BE]" .. LanUtil.getValue(110518) .. "[-]");
	end
	dragData.datas:add("[85A8BE]" .. LanUtil.getValue(110516) .. "[-]");
	dragData.offsetX = -433;
	dragData.offsetY = -150;
	dragData.callBackOwner = self;
	dragData.callBack = self.onDragDownCallBack;
	dragData.selected = self.dragDownList[1].selectedIndex;

	Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end

function Lua_ServantLvlUpPanel:onSubBtnClick2(go)
	self.curDragDownIndex = 2;

	local numStr = string.split(LanUtil.getValue(110507), ",");
	local str = string.split(LanUtil.getValue(110508), ",")[1];
	local dragData = {};
	dragData.datas = Array();
	for i = 16, 3, -1 do
		dragData.datas:add("[85A8BE]" .. numStr[i] .. str .. LanUtil.getValue(110518) .. "[-]");
	end
	dragData.datas:add("[85A8BE]" .. numStr[2] .. str .. LanUtil.getValue(110519) .. "[-]");
	dragData.datas:add("[85A8BE]" .. LanUtil.getValue(110520) .. "[-]");
	dragData.datas:add("[85A8BE]" .. LanUtil.getValue(110516) .. "[-]");
	dragData.offsetX = -152;
	dragData.offsetY = -110;
	dragData.height = 295;
	dragData.callBackOwner = self;
	dragData.callBack = self.onDragDownCallBack;
	dragData.selected = self.dragDownList[2].selectedIndex;

	Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end

function Lua_ServantLvlUpPanel:onSubBtnClick3(go)
	self.curDragDownIndex = 3;

	local numStr = string.split(LanUtil.getValue(110507), ",");
	local str = string.split(LanUtil.getValue(110508), ",")[2];
	local dragData = {};
	dragData.datas = Array();
	for i = 4, 2, -1 do
		dragData.datas:add("[85A8BE]" .. numStr[i] .. str .. LanUtil.getValue(110518) .. "[-]");
	end
	dragData.datas:add("[85A8BE]" .. numStr[1] .. str .. LanUtil.getValue(110519) .. "[-]");
	dragData.datas:add("[85A8BE]" .. LanUtil.getValue(110516) .. "[-]");
	dragData.offsetX = 130;
	dragData.offsetY = -150;
	dragData.callBackOwner = self;
	dragData.callBack = self.onDragDownCallBack;
	dragData.selected = self.dragDownList[3].selectedIndex;

	Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end

function Lua_ServantLvlUpPanel:onFunBtnClick(go)
	if self.itemList == nil then
		return;
	end

	local indexList = Array();
	for i = 1, self.itemList:getSize() do
		if self.itemList[i].isSelected then
			indexList:add(self.itemList[i].voData.index);
		end
	end
	DataCenter.servantLvlUpData:sEatItem(indexList);
end

function Lua_ServantLvlUpPanel:dragDownClick(index)
	self.lvlUpData.tempData.defaultIndex[self.curDragDownIndex] = index;
	self.lvlUpData:setSelectedIndex(self.curDragDownIndex, index)

	self.dragDownList[self.curDragDownIndex].selectedIndex = index;

	self:updateRuleTxt(index);
	self:updateItemList();
	self:reSelect();
end

function Lua_ServantLvlUpPanel:updateRuleTxt(index)
	local dragDown = self.dragDownList[self.curDragDownIndex];
	dragDown.ruleTxt.text = dragDown.ruleTxtList[index];
end

function Lua_ServantLvlUpPanel:reSelect()
	local itemData;
	local color;
	local stage;
	local star;
	for i = 1, self.itemList:getSize() do
		itemData = self.itemList[i];
		itemData.isSelected = false;

		color = itemData.voData.color;
		stage = itemData.voData.order;
		star = itemData.voData.star;
		if itemData.voData.type == 1 then
			if self.selectedColor == nil then
				if color ~= nil then
					itemData.isSelected = false;
				end
			else
				if color ~= nil and color <= self.selectedColor then
					itemData.isSelected = true;
				end
			end

			if self.selectedStage == nil then
				if stage ~= nil then
					itemData.isSelected = false;
				end
			elseif self.selectedStage ~= 0 then
				if stage == nil or(stage ~= nil and stage > self.selectedStage) then
					itemData.isSelected = false;
				end
			end

			if self.selectedStar == nil then
				if star ~= nil then
					itemData.isSelected = false;
				end
			else
				if star == nil or (star ~= nil and star > self.selectedStar) then
					itemData.isSelected = false;
				end
			end
		elseif itemData.voData.subType == 0  then
			itemData.isSelected = true;
		end
	end

	self:setAddingExpText(self:calcExp());
	self.dragList:setLuaArrayData(self.itemList, false);

	Lua_ProxyManager.getProxy("Lua_ServantLvlUpProxy"):checkRedDot();
end

function Lua_ServantLvlUpPanel:itemClick(data)
	for i = 1, self.itemList:getSize() do
		if self.itemList[i] == data then
			self.itemList[i].isSelected = not self.itemList[i].isSelected;
		end
	end

	self:setAddingExpText(self:calcExp());
	self.dragList:setLuaArrayData(self.itemList, false);
end

function Lua_ServantLvlUpPanel:dispose()
	DataCenter.servantData:sServantPanelInfo();
	self:superCall("dispose");
end





--------------------------------------------------





Lua_ServantLvlUpAttrPanel = class("Lua_ServantLvlUpAttrPanel", Lua_DragContainerItem);
function Lua_ServantLvlUpAttrPanel:ctor(p)
	self.height = 104;
	self:superCall("ctor", p);
end

function Lua_ServantLvlUpAttrPanel:setData(data)
	if self.itemArr == nil then
		local item;
		self.itemArr = Array();
		for i = 1, data:getSize() do
			item = Lua_ServantLvlUpAttrItem.new(self.content);
			self.itemArr:add(item);
		end
	end

	self.height = 0;
	for i = 1, self.itemArr:getSize() do
		self.itemArr[i]:setData(data[i]);
		self.itemArr[i]:setLocation(-231, 39 -26 * (i - 1), 0); -- 41-2
		self.height = self.height + self.itemArr[i]:getHeight()
	end
end

function Lua_ServantLvlUpAttrPanel:getHeight()
	return self.height;
end

function Lua_ServantLvlUpPanel:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_ServantLvlUpAttrItem = class("Lua_ServantLvlUpAttrItem", Lua_DisplayObject);
function Lua_ServantLvlUpAttrItem:ctor(p)
	self:superCall("ctor", p, "petAttItem_skin");
end

function Lua_ServantLvlUpAttrItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ServantLvlUpAttrItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.label.text = data.curAttr.attrStr .. "：";

	if data.curAttr.attack_upper == nil then
		self.txt.text = data.curAttr.value;
	else
		self.txt.text = data.curAttr.attack_lower.value .. "-" .. data.curAttr.attack_upper.value;
	end

	if data.curAttr.attack_upper == nil then
		self.increaseTxt.text = data.addedAttrDic[data.curAttr.attrName].nextAttr - data.addedAttrDic[data.curAttr.attrName].curAttr;
	else
		self.increaseTxt.text = data.addedAttrDic["attack_lower"].nextAttr - data.addedAttrDic["attack_lower"].curAttr .. "-" .. data.addedAttrDic["attack_upper"].nextAttr - data.addedAttrDic["attack_upper"].curAttr;
	end

	local posX = self.label.mainContent.transform.localPosition.x + self.label.width;
	local posY = self.label.mainContent.transform.localPosition.y;
	self.txt:setLocation(posX, posY, 0);

	posX = self.txt.mainContent.transform.localPosition.x + self.txt.width + 13;
	posY = self.txt.mainContent.transform.localPosition.y;
	-- self.increaseObj.transform.localPosition = Vector3(posX, posY, 0);
	LuaUtil.setObjPos(self.increaseObj, posX, posY, 0);
end

function Lua_ServantLvlUpAttrItem:getHeight()
	return self.txt.height;
end

function Lua_ServantLvlUpAttrItem:dispose()
	self:superCall("dispose");
end