checkRequire("Lua_PetBasicPanel");
Lua_ServantPanel = class("Lua_ServantPanel", Lua_PetBasicPanel);
function Lua_ServantPanel:ctor(p)
	self.isAdvancing = false;
	self.modelType = 1;
	self:superCall("ctor", p);
end

function Lua_ServantPanel.Get:eventIdList()
	if self._eventIdList == nil then
		self._eventIdList = {funBtn1 = {11111}, funBtn2 = {11112}, comBtn1 = {11113, 11114}, skill = {11115}};
	end
	return self._eventIdList;
end

function Lua_ServantPanel:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("PET_PANEL_UPDATE", self, self.updatePanel);
	self:addLuaEvent("SET_AUTO_LVLUP_TIMER", self, self.setAutoLvlUpTimer);
	self:addLuaEvent("SERVANT_STATE_UPDATE1", self, self.updateFightState);
	DataCenter.servantData:sServantPanelInfo(0);
end

function Lua_ServantPanel:initPanel()
	self:superCall("initPanel");

	self.isShowItemOutPutWindow = true;

	self.panaceaTitle.text = LanUtil.getValue(110529);
	self.upgradeDescTxt.text = LanUtil.getValue(110542);
	self.titleLabel1.text = LanUtil.getValue(110528);
	self.rightBtn1.label = LanUtil.getValue(110504);
	self.rightBtn2.label = LanUtil.getValue(110505);

	self.modelTexture:setCamView(12);
	self.modelTexture:setModelOffset(-347, -197);

	self:updateAutoInfo()
end

function Lua_ServantPanel:updatePanel()
	self.commonData = DataCenter.servantData;
	self.data = self.commonData;
end

function Lua_ServantPanel:setModel()
	self:superCall("setModel");

	self.commonData.selectedServantId = self.modelList[self.curModelIndex].id;
end

function Lua_ServantPanel:onCommonBtn1()
	self:superCall("onCommonBtn1");
end

function Lua_ServantPanel:openTranWin()
	self:superCall("openTranWin");

	Lua_WindowUtil.openWin("Lua_TransWindow", WinParam.ACTION_OPEN, 1);
end

function Lua_ServantPanel:updateCommonBtn2()
	self:superCall("updateCommonBtn2");
	self:setCheckBoxBtnImage();
end

function Lua_ServantPanel:onRightBtn2()
	Lua_WindowUtil.openWin("Lua_ServantLvlUpWindow", WinParam.ACTION_OPEN);
end