Lua_PetDecomposeItem = class("Lua_PetDecomposeItem", Lua_ListCell);
function Lua_PetDecomposeItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_PetDecomposeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(3);
	self.itemImg:setCanClick(false);
	self.itemImg:setDefaultIcon("common_atlas_1", "ui_common_prop_9");

	self.maskIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_black_50", 0, 0, 76, 76);
	self.maskIcon.name = "maskIcon";
	self.maskIcon:setDepth(4);
	self.maskIcon:setEnable(false);

	self.tipsIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_xz", 0, 0, 0, 0);
	self.tipsIcon.name = "tipsIcon";
	self.tipsIcon:setDepth(5);
	self.tipsIcon:setEnable(false);

	self.selectIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_xzk", 0, 0, 80, 82);
	self.selectIcon.name = "selectIcon";
	self.selectIcon:setDepth(6);
	self.selectIcon:setEnable(false);
end

function Lua_PetDecomposeItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local state;
	if type(data) == "number" then
		self.itemImg.data = nil;
		state = false;
	else
		self.itemImg.data = data.vo;
		state = data.selected;
	end
	self.maskIcon:setEnable(state);
	self.tipsIcon:setEnable(state);
	self.selectIcon:setEnable(state);
end

function Lua_PetDecomposeItem:onPlayerSoundClick(go)
	if type(self.data) ~= "number" then
		Lua_MsgUtil.callFunc("ON_PETDECONPOSE_CLICK", self.data);
	end
end

function Lua_PetDecomposeItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	if self.maskIcon ~= nil then
		self.maskIcon:dispose();
		self.maskIcon = nil;
	end
	if self.tipsIcon ~= nil then
		self.tipsIcon:dispose();
		self.tipsIcon = nil;
	end
	if self.selectIcon ~= nil then
		self.selectIcon:dispose();
		self.selectIcon = nil;
	end
    self:superCall("dispose");
end