checkRequire("Lua_PetDecomposeItem")
Lua_PetDecomposeWindow = class("Lua_PetDecomposeWindow", Lua_SecondSizeWindow)
function Lua_PetDecomposeWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_PetDecomposeWindow";
    self.skinName = "PetDecomposeWindow_skin";
    self.isModel = true;
    self.titleText = LanUtil.getValue(127804);
end

function Lua_PetDecomposeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.selectBox.txt:clearListener();
	self.selectBox:addBoxChange(self, self.onSelectedItemClick);

	self.startIndex = 3;
	self.desArr = DataCenter.talePetData.btn_show;
	self.subTxt.text = self.desArr[self.startIndex];

	self.showItem = Lua_ShowItem.new(self.content);
	self.showItem.isWords = true;
	self.showItem.isNum = true;
	self.showItem.isAddNum = true;
	self.showItem.numSpacing = 30;
	self.showItem.addNumSpacing = 20;
	self.showItem.wordsFontSize = 24;
	self.showItem.numFontSize = 24;
	self.showItem.addNumFontSize = 24;
	self.showItem:setLocation(-330, -281.5, 0);

	self.showImg = Lua_ToolImage.new(self.content);
	self.showImg:setDepth(5);
	self.showImg:setScale(0.7, 0.7, 0.7);
	self.showImg:setLocation(-380, -278, 0);
	self.showImg:showItemBg(false);
	self.showImg.data = Lua_ToolVo.new(DataCenter.talePetData.decompose_item);

	self.pack_draglist = Lua_DragList.new(self.content, 1, Vector4(0, 0, 1020, 376));
	self.pack_draglist:setListCell(Lua_PetDecomposeItem, 102, 102, 10);
	self.pack_draglist:setLocation(0, 20, 0);

	self:updatePackListInfo();

	self.fenjieBtn:addClickFuntion(self, self.onFenJieClick);
	self.subBtn:addClickFuntion(self, self.onSubClick);
	self.subBg:addClickFuntion(self, self.onSubClick);

	self:addLuaEvent("ON_PETDECONPOSE_CLICK", self, self.onSelectedClick);
	self:addLuaEvent("UPDATE_TALEPET_PANEL", self, self.onUpdatePanelInfo);
	Lua_ProxyManager.getProxy("Lua_TalePetProxy"):sInitMsg();
end

function Lua_PetDecomposeWindow:updatePackListInfo()
	local arr = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemsBySubType({Lua_PackTypeDefine.TALEPET_ITEM_TYPE, Lua_PackTypeDefine.TALEPET_SOUIL_TYPE});
	self.tempArr = Array();
	for i = 1, arr:getSize() do
		self.tempArr:add({vo = arr[i], selected = false});
	end
	self.pack_draglist:setLuaArrayData(self:minePackSellGoodsArr(self.tempArr), false);
	self:onUpdateSelectedItem();
end

function Lua_PetDecomposeWindow:minePackSellGoodsArr(arr)
	local len = arr:getSize();
	local num = 0;
	if len < 50 then
		num = 50 - len;
	elseif len % 10 > 0 then
		num = 10 -(len % 10);
	end

	for i = 1, num do
		arr:add(i);
	end
	return arr;
end

function Lua_PetDecomposeWindow:onUpdateSelectedItem()
	local list;
	local len = self.tempArr:getSize();
	local decomposeConfig = DataCenter.talePetData.decomposeConfig;
	self.add_count = 0;
	self.pack_indexArr = Array();
	for i = 1, len do
		if type(self.tempArr[i]) ~= "number" and self.tempArr[i] ~= nil and self.tempArr[i].vo ~= nil and self.tempArr[i].selected == true then
			list = {};
			list.index = self.tempArr[i].vo.index;
			list.num = self.tempArr[i].vo.count;
			list.id = self.tempArr[i].vo.id;
			list.decompose_num = decomposeConfig[list.id].decompose_num * self.tempArr[i].vo.count;
			self.add_count = self.add_count + list.decompose_num;
			self.pack_indexArr:add(list)
		end
	end

	local count = DataCenter.talePetData.soul_source;
	if self.add_count ~= 0 then
		self.showItem:setData({wordsStr = LanUtil.getValue(127805), numStr = count, addNumStr = "+" .. self.add_count, addNumColor = "00E125"});
	else
		if count ~= nil then
			self.showItem:setData({wordsStr = LanUtil.getValue(127805), numStr = count});
		end
	end
end

function Lua_PetDecomposeWindow:onSelectedClick(data)
	self.data = data;
	local len = self.tempArr:getSize();
	for i = 1, len do
		if self.data == self.tempArr[i] then
			self.tempArr[i].selected = not self.tempArr[i].selected;
		end
	end
	self.pack_draglist:setLuaArrayData(self:minePackSellGoodsArr(self.tempArr), false);
	self:onUpdateSelectedItem();
end

function Lua_PetDecomposeWindow:onUpdatePanelInfo(data)
	self:updatePackListInfo();
	self:onDragDownCallBack(self.startIndex);
end

function Lua_PetDecomposeWindow:onDragDownCallBack(data)
	self.startIndex = data;
	self.subTxt.text = self.desArr[data];
	self:onOneSelectedItem();
end

function Lua_PetDecomposeWindow:onOneSelectedItem()
	local len = self.tempArr:getSize();
	for i = 1, len do
		if self.startIndex == 1 then
			if type(self.tempArr[i]) ~= "number" and self.tempArr[i] ~= nil and self.tempArr[i].vo ~= nil then
				self.tempArr[i].selected = false;
			end
		else
			if type(self.tempArr[i]) ~= "number" and self.tempArr[i] ~= nil and self.tempArr[i].vo ~= nil
				and self.tempArr[i].vo.color <= self.startIndex
				and self.tempArr[i].vo.subType ~= Lua_PackTypeDefine.TALEPET_SOUIL_TYPE then
				self.tempArr[i].selected = true;
			else
				if type(self.tempArr[i]) ~= "number" and self.tempArr[i].vo.subType ~= Lua_PackTypeDefine.TALEPET_SOUIL_TYPE then
					self.tempArr[i].selected = false;
				end
			end
		end
	end
	self.pack_draglist:setLuaArrayData(self:minePackSellGoodsArr(self.tempArr), false);
	self:onUpdateSelectedItem();
end

function Lua_PetDecomposeWindow:onSelectedItemClick()
	local len = self.tempArr:getSize();
	for i = 1, len do
		if type(self.tempArr[i]) ~= "number" and self.tempArr[i] ~= nil and self.tempArr[i].vo ~= nil and self.tempArr[i].vo.subType == Lua_PackTypeDefine.TALEPET_SOUIL_TYPE then
			self.tempArr[i].selected = self.selectBox.seleted;
		end
	end
	self.pack_draglist:setLuaArrayData(self:minePackSellGoodsArr(self.tempArr), false);
	self:onUpdateSelectedItem();
end

function Lua_PetDecomposeWindow:onFenJieClick()
	if self.pack_indexArr:getSize() == 0 then
		OperateAlert.show(LanUtil.getValue(127808));
		return;
	end
	Lua_ProxyManager.getProxy("Lua_TalePetProxy"):sFenJieMsg(self.pack_indexArr);
end

function Lua_PetDecomposeWindow:onSubClick()
	if self.dragData == nil then
		self.dragData = {};
		self.dragData.datas = self.desArr;
		self.dragData.offsetX = -425;
		self.dragData.offsetY = -90;
		self.dragData.callBackOwner = self;
		self.dragData.callBack = self.onDragDownCallBack;
	end
	self.dragData.selected = self.startIndex;
	Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, self.dragData);
end

function Lua_PetDecomposeWindow:dispose(data)
	if self.showImg ~= nil then
		self.showImg:dispose();
		self.showImg = nil;
	end
	if self.pack_draglist ~= nil then
		self.pack_draglist:dispose();
		self.pack_draglist = nil;
	end
	if self.tempArr ~= nil then
		self.tempArr:dispose();
		self.tempArr:clear();
		self.tempArr = nil;
	end
	if self.pack_indexArr ~= nil then
		self.pack_indexArr:dispose();
		self.pack_indexArr = nil;
	end
	if self.dragData ~= nil then
		self.dragData = nil;
	end

	self:superCall("dispose");
end