Lua_TalePetItem = class("Lua_TalePetItem", Lua_ListCell);
function Lua_TalePetItem:ctor(p)
	self:superCall("ctor", p, "TalePetItem_skin");
end

function Lua_TalePetItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_TalePetItem:setData(data)
	self.data = data
	if data == nil then
		return;
	end

	self.itemBg:setAltas("common_atlas_1", data.headBgName);
	self.itemIcon:setUrl(data.headStr);

	if data.states then
		self.itemIcon:setGray(false);
		self.itemBg:setGray(false);
		self.nameTxt.text = data.colorName;
		self.orderTxt.text = data.orderStr
	else
		self.itemIcon:setGray(true);
		self.itemBg:setGray(true);
		self.nameTxt.text = "[79808C]" .. data.name .. "[-]";

		if data.showRedDot == false then
			self.orderTxt.text = "[FF1616]" .. LanUtil.getValue(127803) .. "[-]";
		else
			self.orderTxt.text = LanUtil.getValue(127809);
		end
	end
	self.orderBg:setEnable(data.states);
	self.redDot:setEnable(data.showRedDot);
end 

function Lua_TalePetItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.bg:setAltas("common_atlas_1", "ui_common_widget_x1");

		if self.data.states then
			self.orderBg:setAltas("common_atlas_2", "ui_common_title_7");
		end
	else
		self.bg:setAltas("common_atlas_1", "ui_common_widget_x2");

		if self.data.states then
			self.orderBg:setAltas("common_atlas_2", "ui_common_title_8");
		end
	end
end

function Lua_TalePetItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("ON_TALEPET_CLICK", self.data);
end

function Lua_TalePetItem:dispose()
	if self.itemBg ~= nil then
		self.itemBg:dispose();
		self.itemBg = nil;
	end
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end