﻿checkRequire("Lua_TalePetItem");
checkRequire("Lua_PetTxtDesItem");
checkRequire("Lua_SkillAnimalItem");
Lua_TalePetPanel = class("Lua_TalePetPanel", Lua_DisplayObject)
function Lua_TalePetPanel:ctor(p)
	self:superCall("ctor", p, "TalePet_skin");
end

function Lua_TalePetPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.skillList = Array();
	self.orderTxt:SetDimensions(30, 200);

	self.talePetList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 286, 560));
	self.talePetList:setLocation(-460, -30, 0);
	self.talePetList:setListCell(Lua_TalePetItem, 106, 286, 1);

	self.desList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 272, 166));
	self.desList:setLocation(365, 73, 0);
	self.desList:setListCell(Lua_PetTxtDesItem, 30, 272, 1);

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.numWidth = 13;
	self.fightNum.numAtlas = "number_atlas";
	self.fightNum:setDepth(6);
	self.fightNum:setLocation(375, 235, 0);

	self.hongdian = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 495, -276, 0, 0);
	self.hongdian.name = "hongdian";
	self.hongdian:setDepth(15);
	self.hongdian.clickScale = false;
	self.hongdian:setEnable(false);

	self.hongdian2 = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 260, -276, 0, 0);
	self.hongdian2.name = "hongdian2";
	self.hongdian2:setDepth(15);
	self.hongdian2.clickScale = false;
	self.hongdian2:setEnable(false);

	self.fenJieBtn:addClickFuntion(self, self.onFenJieBtnClick);
	self.jiHuoBtn:addClickFuntion(self, self.onJiHuoBtnClick);

	self:addLuaEvent("UPDATE_TALEPET_PANEL", self, self.onUpdateList);
	self:addLuaEvent("ON_TALEPET_CLICK", self, self.onTalePetClick);
	Lua_ProxyManager.getProxy("Lua_TalePetProxy"):sInitMsg();
end

function Lua_TalePetPanel:onUpdateList()
	if self.itemImg ~= nil then
		if self.data.cost_item ~= nil then
			self.itemImg:showNumLimit(DataCenter.talePetData.soul_source, self.data.cost_item[2], 2, 3, 50);
		end
	end

	if self.data ~= nil then
		self.hongdian2:setEnable(DataCenter.talePetData.decompose_RedDot and self.data.states);
		self:setBtnInfo(self.data.showRedDot and self.data.isMax == false);
	end

	self.petArr = DataCenter.talePetData.petArr;
	self.talePetList:setLuaArrayData(self.petArr, false);

	local len = self.petArr:getSize();
	local selectedId = DataCenter.talePetData.id;
	if selectedId ~= nil then
		for i = 1, len do
			if self.petArr[i].id == selectedId then
				self:onTalePetClick(self.petArr[i]);
				break;
			end
		end
	end

	if self.isFirstOpen ~= true then
		self.isFirstOpen = true;
		
		self.talePetList:setSelected(1);
		self.talePetList.showList[1]:onPlayerSoundClick();
	end
end

function Lua_TalePetPanel:setBtnInfo(state)
	local normalStr = Lua_ColorDefine.transColor("FFFFFF");
	local grayStr = Lua_ColorDefine.transColor("B6B6B6");
	-- self.jiHuoBtn:setMouseEnable(state);
	self.jiHuoBtn:setStyle(state and 13 or 12);
	self.jiHuoBtn.txt.colorStr = state and normalStr or grayStr;
end

function Lua_TalePetPanel:onJiHuoBtnClick()
	if self.data == nil then
		return;
	end

	if self.data.isMax then
		OperateAlert.show(LanUtil.getValue(127806));
	else
		if self.data.states == false then
			if self.data.showRedDot then
				Lua_ProxyManager.getProxy("Lua_TalePetProxy"):sJiHuoMsg(self.data.id);
			else
				OperateAlert.show(LanUtil.getValue(127811));
			end
		else
			if DataCenter.talePetData.soul_source < self.data.cost_item[2] then
				OperateAlert.show(LanUtil.getValue(127810));
			else
				Lua_ProxyManager.getProxy("Lua_TalePetProxy"):sLevelUpMsg(self.data.id);
			end
		end
	end
end

function Lua_TalePetPanel:onFenJieBtnClick()
	if self.data == nil then
		return;
	end
	Lua_WindowUtil.openWin("Lua_PetDecomposeWindow", WinParam.ACTION_OPEN);
end

function Lua_TalePetPanel:onTalePetClick(data)
	self.data = data;
	if self.modelTexture == nil then
		local imgPos = Vector2(-35, -80);
		local imgSize = Vector2(1175, 680);
		local modelRot = Vector3(0, 180, 0);
		local modelOffset = Vector2(0, -200);
		self.modelTexture = UIModelTexture();
		self.modelTexture:init(self.content, imgPos, imgSize, 8, modelRot, modelOffset, 380);
		self.modelTexture:setRotEnable(true, 9, 34, 460, 400, 8);
		-- self.modelTexture.uiEffect:setGrayShader("Transparent_Gray", "Particle_Gray2");
	end

	self.modelTexture:setEffectActive(false);
	self.modelTexture:addLuaLoadedCallBack(self, self.delayShowModel);

	local size = data.pet_size;
	local pos = data.offsetPos;
	local angle = data.angle;

	--重置角度
	-- self.modelTexture.root.transform.localEulerAngles = Vector3(0, 0, 0);
    LuaUtil.setObjRot(self.modelTexture.root, 0, 0, 0);

	self.modelTexture:setModelAngle(angle[1], angle[2], angle[3])
	self.modelTexture:setModelOffset(pos[1], pos[2], pos[3])
	self.modelTexture.uiEffect:setSacle(size, size, size);
	self.modelTexture:setUrl("/mounts/" .. data.id, tostring(data.id));

	self.desList:setLuaArrayData(data.attrArr, false);

	self.modelName.text = data.name;
	self.fightNum.num = data.force;

	if data.isMax then
		self.desTxt.text = LanUtil.getValue(127806);
		self:setBtnInfo(false);
	else
		self.desTxt.text = LanUtil.getValue(127807);
		self:setBtnInfo(data.showRedDot);
	end

	if self.itemImg == nil then
		self.itemImg = Lua_ToolImage.new(self.content);
		self.itemImg:setDepth(5);
	end

	local posX;
	local spaceWidth = 40;
	if data.states then
		self.orderTxt.text = data.orderStr;
		self.jiHuoBtn.label = LanUtil.getValue(127801);

		if data.cost_item ~= nil then
			posX = self.desTxt.mainContent.transform.localPosition.x + self.desTxt.width + spaceWidth;
			self.itemImg.data = Lua_ToolVo.new(data.cost_item[1])
			self.itemImg:showNumLimit(DataCenter.talePetData.soul_source, data.cost_item[2], 2, 3, 50);
			self.itemImg:setLocation(posX, -293, 0);
		end
	else
		self.orderTxt.text = "[FF1616]" .. LanUtil.getValue(127803) .. "[-]";
		self.jiHuoBtn.label = LanUtil.getValue(127802);

		if data.conditions ~= nil then
			self.des1Txt.text = data.conditions[1]
			if data.conditions[2] == nil then
				self.tipsIcon2:setEnable(false);
				self.des2Txt.text = "";
			else
				self.tipsIcon2:setEnable(true);
				self.des2Txt.text = data.conditions[2];
			end
		end

		if data.activation_cost ~= nil then
			self.itemImg.data = Lua_ToolVo.new(data.activation_cost[1]);

			local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(data.activation_cost[1]);
			self.itemImg:showNumLimit(hadCount, data.activation_cost[2], 2, 3, 50);

			local width = self.des1Txt.width > self.des2Txt.width and self.des1Txt.width or self.des2Txt.width;
			posX = self.des1Txt.mainContent.transform.localPosition.x + width + spaceWidth;
			self.itemImg:setLocation(0, -293, 0);
		end
	end

	-- 技能
	local skillItem;
	local skillLen = data.skillArr:getSize();
	for i = 1, skillLen do
		skillItem = self.skillList[i];
		if skillItem == nil then
			skillItem = Lua_SkillAnimalItem.new(self.content);
			skillItem.content.name = "Lua_SkillAnimalItem" .. i;
			skillItem:showLvlTxt(false);
			skillItem:setDepth(4);
			skillItem:setLocation(425 - (i % 2) * 120, -90 - (math.ceil(i / 2) - 1) * 95, 0);
			self.skillList:add(skillItem);
		end
		skillItem:setEnable(true);
		skillItem:setInfo(data.skillArr[i]);
	end

	for i = self.skillList:getSize(), skillLen, -1 do
		if i > skillLen then
			self.skillList[i]:setEnable(false);
		end
	end

	-- self.modelTexture.uiEffect:setGray(not data.states);
	self.desTxt:setEnable(data.states);
	self.itemImg:setEnable(not data.isMax);
	self.infoObj:SetActive(not data.states);
	self.fenJieBtn:setEnable(data.states);

	self.hongdian:setEnable(data.showRedDot and data.isMax == false)
	self.hongdian2:setEnable(DataCenter.talePetData.decompose_RedDot and data.states)
end

function Lua_TalePetPanel:delayShowModel()
	self.modelTexture:setEffectActive(true);
end

function Lua_TalePetPanel:dispose()
	if self.talePetList ~= nil then
		self.talePetList:dispose();
		self.talePetList = nil;
	end
	if self.desList ~= nil then
		self.desList:dispose();
		self.desList = nil;
	end
	if self.fightNum ~= nil then
		self.fightNum:dispose();
		self.fightNum = nil;
	end
	if self.hongdian ~= nil then
		self.hongdian:dispose();
		self.hongdian = nil;
	end
	if self.hongdian2 ~= nil then
		self.hongdian2:dispose();
		self.hongdian2 = nil;
	end
	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil;
	end
	if self.skillList ~= nil then
		self.skillList:dispose();
		self.skillList = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end